%!TEX root = ../document.tex

\tikzstyle{input} = [draw, fill=none, rectangle, text width = 4cm, align=center, minimum height = 2em]
\tikzstyle{value} = [draw, fill=none, rectangle, rounded corners, text width = 2.5cm, align=center, minimum height = 2em]
\tikzstyle{strategy} = [draw, fill=none, rectangle, text width = 2cm, align=center, shape aspect=1.5]

\begin{tikzpicture}[auto,>=latex,node distance=0.5cm,line width=1pt]
    \setitemize[0]{leftmargin=0.5cm}
    
    % Input parameters
    \node [input] (hardware) {Hardware};
    \node [input, below=of hardware] (dictionary) {
    	Dictionary Variant
    	\vspace*{0.2cm}
    	\begin{itemize}
    		\item Compression Model
    		\item Runtime Extract per String
    		\item Runtime Locate per String
    		\item Runtime Construct per String
		\end{itemize}
    };
    \node [input, below = of dictionary] (column) {
    	Column
    	\vspace*{0.2cm}
    	\begin{itemize}
    		\item Number Extracts
    		\item Number Locates
    		\item Column Type
    		\item Size of Index Vector
    		\item Merge frequency
    		\item Data
		\end{itemize}
    };
    \node [input, below = of column] (system) {
    	Database System
    	\vspace*{0.2cm}
    	\begin{itemize}
    		\item Occupied Memory Size
    		\item Available Memory Size
		\end{itemize}
    };
    \node[fit=(dictionary)(hardware)(column)(system)](group){};
    
    % Intermediate result values
    \node [value,    node distance=1cm, right=of group] (size) {Dictionary Size};
    \node [value,    node distance=1.5cm, above=of size] (runtime) {Runtime in Dictionary};
    \node [value,    node distance=1.5cm, below=of size] (goal) {Optimization Goal};
    \node [strategy, node distance=0.75cm, right=of size, diamond] (strategy) {Selection Strategy};
    
    % Group intermediate result values together
    \node[value, dashed, fit=(size)(runtime)](perdictionary){};
    \node[node distance=0cm, above right=of perdictionary]{Per Dictionary Variant};
    
    \node[value, dashed, fit=(goal)](percolumn){};
    \node[node distance=0cm, below right=of percolumn]{Per Column};
    
    % Connections (parameter -> intermediate value)
    \draw[->,dashed] (hardware.south east)  --     (runtime);
    \draw[->]        (dictionary)           --     (runtime);
    \draw[->]        (dictionary)           --     (size);
    \draw[->]        (column)               --     (runtime);
    \draw[->]        (column)               --     (size);
    \draw[->]        (column)               --     (goal);
    \draw[->]        (system)               --     (goal);
    
    % Connections (intermediate value -> Strategy)
    \draw[->]        (runtime)              --     (strategy);
    \draw[->]        (size)                 --     (strategy);
    \draw[->]        (goal)                 --     (strategy);
\end{tikzpicture}